Index: Thuban/UI/renderer.py
===================================================================
RCS file: /home/thuban/jail/thubanrepository/thuban/Thuban/UI/renderer.py,v
retrieving revision 1.53
diff -u -r1.53 renderer.py
--- Thuban/UI/renderer.py	3 Jan 2005 16:21:17 -0000	1.53
+++ Thuban/UI/renderer.py	20 Jan 2005 16:17:17 -0000
@@ -22,7 +22,8 @@
     wxTRANSPARENT_PEN, wxTRANSPARENT_BRUSH, \
     wxBLACK_PEN, wxBLACK, wxSOLID, wxCROSS_HATCH, wxSWISS, wxNORMAL, \
     wxBitmapFromImage, wxImageFromStream, wxBITMAP_TYPE_BMP, \
-    wxBITMAP_TYPE_JPEG, wxBITMAP_TYPE_PNG, wxBITMAP_TYPE_TIF, wxBITMAP_TYPE_GIF
+    wxBITMAP_TYPE_JPEG, wxBITMAP_TYPE_PNG, wxBITMAP_TYPE_TIF, \
+    wxBITMAP_TYPE_GIF, wxEmptyImage
 
 from wxproj import draw_polygon_shape, draw_polygon_init
 
@@ -38,6 +39,10 @@
 
 from baserenderer import BaseRenderer
 
+from math import floor
+
+from types import StringType
+
 
 # Map the strings used for the format parameter of the draw_raster_data
 # method to the appropriate wxWindows constants
@@ -99,11 +104,27 @@
         return wxFont(int(round(self.resolution * 10)), wxSWISS, wxNORMAL,
                       wxNORMAL)
 
-    def draw_raster_data(self, data, format = 'BMP'):
-        stream = cStringIO.StringIO(data)
-        image = wxImageFromStream(stream, raster_format_map[format])
+    def draw_raster_data(self, x,y, data, format = 'BMP', mask = None):
+        if format == 'RAW':
+            image = wxEmptyImage(data[0], data[1])
+            image.SetData(data[2])
+        else:
+            stream = cStringIO.StringIO(data[2])
+            image = wxImageFromStream(stream, raster_format_map[format])
+
         bitmap = wxBitmapFromImage(image)
-        self.dc.DrawBitmap(bitmap, 0, 0)
+
+        if mask is None:
+            self.dc.DrawBitmap(bitmap, int(round(x)), int(round(y)), False)
+        else:
+            # if we are given a mask object, try to pass it to SetMaskColour,
+            # otherwise assume it's a mask image
+            try:
+                bitmap.SetMaskColour(mask);
+                self.dc.DrawBitmap(bitmap, int(round(x)), int(round(y)), True)
+            except (TypeError):
+                # implement using a mask image
+                raise NotImplementedError
 
 
 class ScreenRenderer(MapRenderer):
